/*
 *  
 */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>

#include "compile.h"
#include "strutils.h"

extern int mkdir (char *path, unsigned mode);

typedef struct {
  char *fname;
  char *pat;
  char *title;
} Fak;

#define MAXFAK 200

Fak fakoj[MAXFAK];

void load_fak() {
  FILE *f;
  char s[MAXLEN];
  char *pat,*fname,*title;
  char *ss,*p,*pp;
  int i;

  f=fopen("fak.cfg","r");
  if (f==NULL) return;

  i=0;
  while (fgets(s,sizeof(s)-1,f) && i<MAXFAK-1) {
    p=strchr(s,'\n');
    if (p) *p=0;
    p=strchr(s,'\r');
    if (p) *p=0;

    ss=s;

    p=strchr(ss,':');
    if (p==NULL) continue;
    pp=p+1;
    p--;
    while (p>ss && *p==' ') p--;
    p++;
    *p=0;
    fname=strdup(ss);
    ss=pp;
    while (*ss==' ') ss++;

    p=strchr(ss,':');
    if (p==NULL)
      p=ss+strlen(ss)-1;
    pp=p+1;
    p--;
    while (p>ss && *p==' ') p--;
    p++;
    *p=0;
    pat=strdup(ss);
    ss=pp;
    while (*ss==' ') ss++;

    title=strdup(ss);

    fakoj[i].fname=fname;
    fakoj[i].pat=pat;
    fakoj[i].title=title;
    i++;
  }
  fclose(f);
  fakoj[i].fname=NULL;
  fakoj[i].pat=NULL;
  fakoj[i].title=NULL;
} //load_fak

char fname[MAXLEN], FakOutPath[MAXLEN];
FILE *faktmp, *fpattern, *fipattern;

extern FILE *prologue (FILE *out, char *name, char *title);
extern void epilogue (FILE *out, FILE *f, char *title);

void prol_index(void) {
  char s[MAXLEN];
  int i,j;
  FILE *f;

  strcpy(s,FakOutPath);
  strcat(s,"i_fak.html");

  f=fopen(s,"wb");
  fipattern=prologue(f,"ifak.pat","");

  for (i=0; fakoj[i].fname; i++) {
    for (j=0; j<i; j++) {
      if (strcmp(fakoj[i].fname,fakoj[j].fname)==0) goto x;
      if (strcmp(fakoj[i].pat,fakoj[j].pat)==0) {
        fprintf(f,"&nbsp;&nbsp;&nbsp;&nbsp;");
        break;
      }
    }
    fprintf(f,"<a href=\"%s\" target=\"left\">",fakoj[i].fname);
    fputStrUni(f,fakoj[i].title);
    fprintf(f,"</a><br />\n");
x:  ;
  } //for

  epilogue(f,fipattern,"");

  fclose(f);
} //prol_index

void fak_prolog(FILE *f, char *s) {
  int i;

  fpattern=prologue(f,"fak.pat","");

  for (i=0; fakoj[i].fname; i++) {
    if (strcmp(fakoj[i].fname,s)==0)
      fputStrUni(f,fakoj[i].title);
  }
  fprintf(f,"<hr />\n");
} //fak_prolog

void fak_epilog(FILE *f) {
  epilogue(f,fpattern,"");
  fclose(f);
} //fak_epilog

extern int it;

char w[MAXLEN];
int checkFak(char **p, char *fak) {
  char *s;

  if (strncmp(*p,fak,strlen(fak))) return 0;
  if (*(*p-1)=='.') return 0;
  if ((unsigned)(*(*p-1))>128) return 0;
  if ((unsigned)((*p)[strlen(fak)])>128) return 0;
  strcpy(w,word0);
  while(rep(w," II",""));
  while(rep(w," I,",","));
  if (strcmp(w+strlen(w)-1,"I")==0)
    w[strlen(w)-1]=0;
  return 1;
} //checkFak

int my_userMatch (char **p) {
  int i, res;

  if (faktmp==NULL)
    faktmp=fopen("faktmp","w");
  if (!it) return 0;
  res=0;
  for (i=0; fakoj[i].fname; i++) {
    if (checkFak(p,fakoj[i].pat)) {
      fprintf(faktmp,"%s: %s%s: ",fakoj[i].fname,fname,addr);
      fprintf(faktmp,"<a href=\"../%s#%s\">",fname,addr);
      fputStrUni(faktmp,w);
      fprintf(faktmp,"</a><br />\n");
      res=1;
    }
  }
  return res;
} //my_userMatch

FILE *FF;
char oldfak[MAXLEN];

void make_fak() {
  char s[MAXLEN],s0[MAXLEN],ss[MAXLEN],name[MAXLEN];
  char *p,*pp;

  fclose(faktmp);

  //exit(0);

  fprintf(stderr,"   *** Fakindeksoj ***\n");
  
  #ifdef WIN32
    system("sort faktmp >faktmp1");
  #else
    system("LANG=ru_RU.cp1251 LC_COLLATE=ru_RU sort faktmp >faktmp1");
  #endif

  unlink("faktmp");

  s0[0]=0;

  prol_index();

  faktmp=fopen("faktmp1","r");
  if (faktmp==NULL) return;

  while (!feof(faktmp)) {
    fgets(s,sizeof(s)-1,faktmp);
    if (feof(faktmp)) break;
    p=strchr(s,'\n'); if (p) *p=0;
    p=strchr(s,'\r'); if (p) *p=0;
    if (strcmp(s,s0)==0) continue;
    strcpy(s0,s);
    p=strstr(s,": ");
    if (p==NULL) continue;
    *p=0; p+=2;
    p=strstr(p,": ");
    if (p==NULL) continue;
    *p=0; p+=2;
    strcpy(ss,FakOutPath);
    strcat(ss,s);
    if (strcmp(oldfak,ss)) {
      strcpy(name,s);
      pp=strchr(name,'.');
      if (*pp) *pp=0;
      fprintf(stderr,"%s ",name);
      if (FF)
        fak_epilog(FF);
      FF=fopen(ss,"wb");
      fak_prolog(FF,s);
      strcpy(oldfak,ss);
    }
    fprintf(FF,"%s\n",p);
  }
  if (FF) fak_epilog(FF);
  //fprintf(stderr,"\n");

  fclose(faktmp);

  unlink("faktmp1");
}
